### Solutions for Project 1 
### Course: Statistics II
### Designed by the STATISTICS GROUP 2018-19 

### THIS CODE WITH COMMENTS FOR THE SOLUTIONS IS DISTRIBUTED ONLY FOR ACADEMIC PURPOSES
### AND CAN BE USED AND REDISTRIBUTED PARTLY ONLY FOR SUCH REASONS
### IT IS DESTINED FOR BEGINNERS IN R AND STATISTICS AND SPECIFICALLY DESIGNED
### FOR THE NEEDS OF THE STUDENTS OF THE COURSE  

## Code Assignment
# (1)
df = data.frame(letters, numbers = 1:26); 
name = strsplit("pamegerageraa","")
surname = strsplit("stinergasia","") #243
code = c(name[[1]], "w", surname[[1]])
code = factor(code, levels = letters, labels = df$numbers)
code = sum(as.numeric(code)); code
# (OR) code = sum(df$numbers[code]); code

# (2)
set.seed(code)

## Main Assignment
# (1)
X = rexp(500, 1) # 500 simulations from Exp(1)

pdf() # automatically named Rplots

hist(X, breaks = "FD", freq = FALSE, col = "grey", border = "purple", main = "Q1: Histogram of 500 draws from Exp(1)")

# adding the density function
curve(dexp(x, 1), col = "red", add = TRUE, lty = 4, lwd = 2) 

# (2)
X20 = X[1:20]
ks.test(X20, "pexp", 1)
# C: the null hypothesis cannot be rejected (no signs for departure from Exp(1))

d = 20 / 5
breaks = qexp(0:d / d, 1) # C: equiprobable intervals
h = hist(X20, breaks, plot = FALSE)
chisq.test(h$counts)
# C: high p-value similar to the KS-test, same conclusion

# (OR) chisq.test(h$counts, simulate.p.value = TRUE)
# simulation of p-value allows better precision for small samples

# (OR) observed = table(cut(X20, breaks))
# theor = rep(5, d)
# x = sum((observed - theor)^2 / theor); x
# pvalue = 1 - pchisq(x, d - 1); pvalue

X100 = X[1:100]
ks.test(X100, "pexp", 1)
# C: the p-value increases, so the conclusion is even better supported

d = 100 / 10
# C: increasing the number of intervals could further increase p-value
breaks = qexp(0:d / d, 1)
h = hist(X100, breaks, plot = FALSE)
chisq.test(h$counts)
# C: very high p-value as expected

ks.test(X, "pexp", 1)
# C: The K-S test needs a large sample to increase sufficiently its p-value

d = 500 / 10
# finding the best way for bin separation is not a problem that we are interested in
breaks = qexp(0:d / d, 1)
h = hist(X, breaks, plot = FALSE)
chisq.test(h$counts)
# C: also very high p-value

# (3)
testExp = function(N, n, a, lambda = 1)
{
  kscount = 0
  chisqcount = 0
  # this is just one simple possibility
  d = floor(n / 10)
  if (n < 100)
  {
    d = floor(n / 5)
  }
  breaks = qexp(0:d / d, 1)
  for (j in 1:N)
  {
    Y = rexp(n, lambda)
    ks = ks.test(Y, "pexp", 1)
    if (ks$p.value < a)
    {
      kscount = kscount + 1
    }
    h = hist(Y, breaks, plot = FALSE)
    chisq = chisq.test(h$counts)
    if (chisq$p.value < a)
    {
      chisqcount = chisqcount + 1
    }
  }
  return(c(kscount / N, chisqcount / N))
}

testExp(10^5, 20, 0.05)
testExp(10^5, 500, 0.05)

# C: It is very interesting to notice that in 100K tests
# the ks-test rejects the null hypothesis almost 5% of the times as expected from theory
# even if the sample size is small (for n=20)
# in contrast to the chi-square test, which rejects less than expected.
# Be careful! You should not be confused and say that it is better if it rejects less 
# The chi-square test should perform better with simulated p-values but it is 
# not the purpose here. When n=500 the ks-test attains with great precision the theoretical
# value and the chi-square test performs worse than the ks-test, but really better
# than the chi-square test with n=20.

# (4)
U1 = 1 - exp(-X) # F(X) follows Unif(0,1) from theory since X is a continuous r.v.
# (OR) U1 = exp(-X)
# since 1-U follows Unif(0,1) if U follows Unif(0,1)
U2 = runif(100, 0, 1)

ks.test(U1, U2)
# ks-test for homogeneity in 2 independent samples

wilcox.test(U1, U2)
# Wilcoxon rank sum test with continuity correction

#C: Both tests indicate that there are no reasons to reject homogeneity
# in all the usual significance levels

# we conclude with a chi-square homogeneity test
d = 100 / 10
breaks = 0:d / d
breaks = qunif(0:d / d)
# (OR) breaks = 0:d / d
h1 = hist(U1, breaks, plot = FALSE)
h2 = hist(U2, breaks, plot = FALSE)
chisq.test(rbind(h1$counts, h2$counts))
#C: a high p-value which supports homogeneity

# (5)
X = -log(1 - U2) # inverse probability transform
# (OR) X = -log(U2)
# since 1 - U2 follows Unif(0,1) if U2 follows Unif(0,1)

E20 = E[1:20]
ks.test(E20, "pexp", 1)

d = 20 / 5
breaks = qexp(0:d / d, 1)
h = hist(E20, breaks, plot = FALSE)
chisq.test(h$counts, simulate.p.value = TRUE)

ks.test(E, "pexp", 1)

d = 100 / 10
breaks = qexp(0:d / d, 1)
h = hist(E, breaks, plot = FALSE)
chisq.test(h$counts)

#C: Both results do not reject H0 in the usual signif. levels.

# (6)
mu = seq(-sqrt(2) + 1e-10, sqrt(2) - 1e-10, length.out = 1000)
sigma = sqrt(2 - mu^2)
muY = sigma * sqrt(2 / pi) * exp(-mu^2 / (2 * sigma^2)) + mu * (1 - 2 * pnorm(-mu / sigma))
plot(mu, muY, type = "l", ylim = c(1, max(muY)), col = "blue", lty = 4, lwd = 2, main = "Q6: Plot of Expected Value of Folded Normal Distribution")
abline(h = 1, col = "red", lty = 4, lwd = 2)

# (7)
testExp = function(N, n, a, dist = "exp", lambda = 1, mu = 0, sd = 1, shift = 0)
{
  kscount = 0
  chisqcount = 0
  d = floor(n / 10)
  if (n < 100)
  {
    d = floor(n / 5)
  }
  breaks = qexp(0:d / d, 1)
  if (dist == "foldnorm" && shift < 0)
  {
    breaks[1] = shift
  }
  # the command above incorporates negative values in the first interval
  for (j in 1:N)
  {
    if (dist == "exp")
    {
      Y = rexp(n, lambda)
    }
    else if (dist == "foldnorm")
    {
      Y = abs(rnorm(n, mu, sd)) + shift
    }
    else
    {
      return(-1)
    }
    ks = ks.test(Y, "pexp", 1)
    if (ks$p.value < a)
    {
      kscount = kscount + 1
    }
    h = hist(Y, breaks, plot = FALSE)
    chisq = chisq.test(h$counts)
    if (chisq$p.value < a)
    {
      chisqcount = chisqcount + 1
    }
  }
  return(c(kscount / N, chisqcount / N))
}

testExp(10^4, 20, 0.05, "foldnorm", sd = sqrt(pi / (pi - 2)), shift = 1 - sqrt(2 / (pi - 2)))
testExp(10^4, 100, 0.05, "foldnorm", sd = sqrt(pi / (pi - 2)), shift = 1 - sqrt(2 / (pi - 2)))

# Notice that the KS test rejects H0 two times more than the chi-square test with n=20.
# Both have a low score. Things change when n=100. Both have a high rejectance ratio.
# This test approximates the power of the test when the shifted folded normal is the true distribution,
# so it approximates the ability of this test to correctly reject H0 with a=0.05 (or correctly
# accept H1), when the shifted folded normal is the true distribution.
# For large n here, it is interesting to notice that chi-square distinguishes better
# this type of departure from the exponential distribution.

# (8)
# computation of the point at which F(x)=1
xmax = (exp(1) - 1)^(17 / 4); xmax

X = numeric(365)
U = runif(365, 0, 1)
X[U > 0.5] = (exp(2 * U[U > 0.5] - 1) - 1)^(17 / 4)
# (OR) I = rbinom(365, 1, 0.5)
# U = runif(sum(I), 0, 1)
# X[I == 1] = (exp(U) - 1)^(17 / 4)

# Since F is discontinuous at 0, there is 0.5 probability to be null (no earthquake)
# In this way, the generalised inverse assigns 0, when the uniform 0 < Ui < 0.5 (eqiv. I=0) 
# Otherwise, the classical inverse is computed

hist(X, breaks = "FD", freq = FALSE, col = "grey", border = "purple", main = "Q8: Histogram of 365 draws from F")

# hist(X[U > 0.5], breaks = "FD", col = "grey", border = "purple", main = "Q8: Histogram of positive draws from F")

plot(ecdf(X), col = "red", verticals = TRUE, do.points = FALSE, xlim = c(0, xmax), main = "Q8: Plot of Empirical CDF of X")
curve(0.5 + 0.5 * log(1 + x^(4 / 17)), col = "blue", add = TRUE)

# (OR):
# n = sum(U > 0.5)
# prob = 1 - n / 365
# Y = sort(X[U > 0.5])
# plot(c(0, 0), c(0, prob), type = "l", col = "red", xlim = c(0, xmax), ylim = c(0, 1), xlab = "X", ylab = "F", main = "Q8: Plot of Empirical CDF of X")
# lines(c(0, Y[1]), c(prob, prob), col = "red")
# by = 1 / 365
# for (i in 1:(n - 1))
# {
#   lines(c(Y[i], Y[i]), c(prob, prob + by), col = "red")
#   lines(c(Y[i], Y[i + 1]), c(prob + by, prob + by), col = "red")
#   prob = prob + by
# }
# lines(c(Y[n], Y[n]), c(prob, prob + by), col = "red")
# lines(c(Y[n], xmax), c(prob + by, prob + by), col = "red")
# curve(0.5 + 0.5 * log(1 + x^(4 / 17)), col = "blue", add = TRUE)
# abline(h = 0, col = "grey", lty = 2)
# abline(h = 1, col = "grey", lty = 2)

dev.off()

# (9)
library(nortest)

load("data.RData", verbose = TRUE)
df = rbind(df1, df2, df3)

maleheight = df$height[df$gender == 0]
maleweight = df$weight[df$gender == 0]
femaleheight = df$height[df$gender == 1]
femaleweight = df$weight[df$gender == 1]

shapiro.test(maleheight)
lillie.test(maleheight)

# Results from Shapiro-Wilk normality test indicate that 
# that normality for male heights cannot be rejected in the usual signif. levels.
# Note that the Lilliefors test rejects normality with a=0.05,
# but the p-value is not so low. Contradictory results from different tests
# could appear and the assessing the power of each test is important in these
# cases.

shapiro.test(maleweight)
lillie.test(maleweight)

# Normality for male weights would be rejected with Shapiro-Wilk
# even in the more stringent level a=0.001
# but the Lilliefors test contrasts this conclusion.

shapiro.test(femaleheight)
lillie.test(femaleheight)

# Both tests reject normality for female heights with a=0.05 
# but not with a=0.01. 

shapiro.test(femaleweight)
lillie.test(femaleweight)

# Departure from normality for female weights can be supported
# with the Shapiro-Wilk in the less stringent levels a=0.05 and a=0.01
# but for Lilliefors only with a=0.05 (or more)

# (10)
proba = df$proba
stat1 = df$stat1

chisq.test(proba, stat1, simulate.p.value = TRUE)
# (OR) contingency = table(proba, stat1); tab
# chisq.test(contingency, simulate.p.value = TRUE)

cor.test(proba, stat1, use = "complete.obs")
cor.test(proba, stat1, use = "complete.obs", method = "spearman")

# We can use for example the classical Pearson correlation coefficient and
# the Spearman one to indicatate that the notes are indeed sufficiently correlated
# as expected from our intuition

# (11)
wilcox.test(proba, stat1, paired = TRUE)
# (OR) diff = proba - stat1
# wilcox.test(diff)

# We can use a pairwise Wilcoxon signed rank test with continuity correction
# to test for statistically significant differences between the notes.
# The results indicate that there is no significan difference even with a=0.1
# since the p-value is high.
